<?php

function CBFWZonesPage($urls)
{
	global $BASE_URL, $MENU_ITEMS;
	$comms = new Comms();
	
	if(isset($urls[1])) {
		switch($urls[1]) {
			case "modify":
				
				if($_REQUEST["description"] != "") $desc = $_REQUEST["description"];
				else $desc = null;
				
				$oldname = $_REQUEST["oldname"];
				$newname = $_REQUEST["zonename"];
				
				$renewname = null;
				error_log("comparing \"$oldname\" to \"$newname\"");
				if($oldname != $newname) {
					$renewname = " rename $newname";
				}
				
				$oldconf = getWebUserConfig();
				$olddesc = $oldconf["zone"][$oldname]["description"];
				error_log("Comparing \"$olddesc\" and \"$desc\"");
				if($desc != $olddesc) {
					$newdesc = " # $desc";
				} else $newdesc = null;
				
				//echo "confs: \"$olddesc\", \"$newdesc\", $oldname, $newname<br>";
				//exit(0);
				
				if($renewname == null && $newdesc == null) {
					header("Location: $BASE_URL/zones");
					error_log("no changes?");
					return;
				}
				
				
				$conf = $comms->getConfig(3);
				$changes = $conf["status"];
				if($changes == "nochange") $conf["status"] = 1;
				else $conf["status"] = $changes + 1;
				$cnum = $conf["status"];
				
				$conf[$cnum]["modify"] = "zone $oldname$renewname$newdesc";
				$comms->putConfig($conf, 3);
				header("Location: $BASE_URL/zones");
				
				break;
				
				
			case "edit":
				CBFWpageBuilder(null, "CBFWZonesEditPage", null, null, $urls);
				break;
				
				
			case "delete":
				$zonetodelete = $urls[2];
				
				$conf = $comms->getConfig(3);
				$changes = $conf["status"];
				if($changes == "nochange") $conf["status"] = 1;
				else $conf["status"] = $changes + 1;
				$cnum = $conf["status"];
				
				$conf[$cnum]["delete"] = "zone $zonetodelete";
				$comms->putConfig($conf, 3);
				header("Location: $BASE_URL/zones");
				break;
				
				
			case "add":
				
				// UGLY
				$cnum = 0;
				$nametoadd = $_REQUEST["toadd"];
				$desc = $_REQUEST["desc"];
				$descbit = "";
				if($desc != "") $descbit = " # $desc";
				if($nametoadd == "" || $nametoadd == null) {
					return;
				}
				$conf = $comms->getConfig(3);
				$changes = $conf["status"];
				if($changes == "nochange") $conf["status"] = 1;
				else $conf["status"] = $changes + 1;
				$cnum = $conf["status"];
				$conf[$cnum]["add"] = "zone $nametoadd$descbit";
				$comms->putConfig($conf, 3);
				header("Location: $BASE_URL/zones");
				break;
				
				
			default:
				CBFWpageBuilder(null, "CBFWZonesPageDisplay");
		}
	} else {
		CBFWpageBuilder(null, "CBFWZonesPageDisplay");
	}
}

function CBFWZonesEditPage($urls)
{
	global $BASE_URL, $MENU_ITEMS;
	
	$zone = $urls[2];
	
	$config = getWebUserConfig();
	
	
	echo "<h2>Edit Zone $zone</h2>";
	echo "<form method=\"post\" action=\"$BASE_URL/zones/modify/$zone\">";
	echo "<input type=\"hidden\" name=\"oldname\" value=\"$zone\">";
	echo "Name: <input type=\"text\" name=\"zonename\" value=\"$zone\"><br>";
	
	if(isset($config["zone"][$zone]["description"])) $desc = $config["zone"][$zone]["description"];
	
	echo "Description: <input type=\"text\" name=\"description\" value=\"$desc\"><br>";
	echo "<input type=\"submit\" name=\"Go\" value=\"Go\">";
	echo "</form>";
}

function getWebUserConfig()
{
	$comms = new Comms();
	$myconf = new Config();
	
	
	// check to see if pre-cache config matches change level of config change buffer
	$config = $comms->getConfig(5);
	$conf2 = $comms->getConfig(3);
	if(isset($config["status"])) {
		if($config["status"] == $conf2["status"]) {
			// it did, return the pre-cache
			error_log("got pre-cache config");
			return $config;
		}
	}
	
	// it did not, do a new merge and cache
	$config = $myconf->mergeConfig($comms->getConfig(), $conf2);
	$reconfig = $config;
	$reconfig["status"] = $conf2["status"];
	error_log("put pre-cache config");
	$comms->putConfig($reconfig, 5);	
	
	return $config;
}

function CBFWZonesPageDisplay()
{
	global $BASE_URL, $MENU_ITEMS;
	
	$config = getWebUserConfig();

	echo "<h2>Zones</h2>";
	echo "<table border=\"1\"><tr><th>Zone</th><th>Interfaces</th><th>Description</th><th>Edit</th></tr>";
	foreach($config["zone"] as $key => $var) {
		$name = $key;
		$url = "<a href=\"$BASE_URL/zones/edit/$name\">Edit</a>";
		$url2 = "<a href=\"$BASE_URL/zones/delete/$name\">Delete</a>";
		$desc = $var["description"];
		echo "<tr><td>$name</td><td>...</td><td>$desc</td><td>$url $url2</td></tr>";
	}
		
	echo "</table><br>";
	echo "<form method=\"post\" action=\"$BASE_URL/zones/add\">";
	echo "<hr><h3>Add Zone</h3><br>";
	echo "Name: <input type=\"text\" name=\"toadd\"><br>";
	echo "Description: <input type=\"text\" name=\"desc\"><br>";
	echo "<input type=\"submit\" name=\"Add\" value=\"Add\">";
	echo "</form>";
	
}

function CBFWInterfacesPage($urls)
{
	if(isset($urls[1])) {
		switch($urls[1]) {
			case "edit":
				CBFWpageBuilder(null, "CBFWInterfacesPageEdit", null, null, $urls[2]);
				break;
			case "change":
				CBFWInterfacesChange();
				break;
			default:
				CBFWpageBuilder(null, "CBFWInterfacesPageDisplay");
		}
	} else {
		error_log("main interface page");
		CBFWpageBuilder(null, "CBFWInterfacesPageDisplay");
	}
}

function CBFWInterfacesChange()
{
	global $BASE_URL, $MENU_ITEMS;
	$comms = new Comms();
	
	$comms->sendMessage("interface eth0 changename poof");
	header("Location: $BASE_URL/interfaces");
}

function CBFWInterfacesPageEdit($urls)
{
	global $BASE_URL, $MENU_ITEMS;
	$interface = $urls;
	
	echo "<h3>Edit Interface $interface</h3><br>";
	echo "<form method=\"post\" action=\"$BASE_URL/interfaces/change/$interface\">";
	echo "<table>";
	echo "<tr><td>Name</td><td><input type=\"text\" name=\"name\"></td></tr>";
	echo "<tr><td>HW Address</td><td><input type=\"text\" name=\"hwaddr\"></td></tr>";
	echo "<tr><td>Zone</td><td><input type=\"text\" name=\"zone\"></td></tr>";
	echo "<tr><td>IPv4 Address</td><td><input type=\"text\" name=\"ipv4addr\"></td></tr>";
	echo "<tr><td>IPv6 Address</td><td><input type=\"text\" name=\"ipv6addr\"></td></tr>";
	echo "<tr><td>Speed</td><td><input type=\"text\" name=\"speed\"></td></tr>";
	echo "<tr><td>Duplex</td><td><input type=\"text\" name=\"duplex\"></td></tr>";
	echo "</table>";
	echo "<input type=\"submit\" name=\"Change\" value=\"Change\"><br>";
	//echo "<a href=\"$BASE_URL/interfaces/\">Back</a>";
	echo "</form>";
}

function CBFWInterfacesPageDisplay()
{
	global $BASE_URL, $MENU_ITEMS;
	$comms = new Comms();
	
	$config = $comms->getConfig(0);
	$boot_config = $comms->getConfig(1);
	
	// now build an interface table
	$table = array();
	foreach($boot_config["hardware"]["netdev"] as $key=>$val) {
		$ename = $key;
		$table[$key]["realname"] = $val["name"];
		$table[$key]["name"] = $val["name"];
		
		
		// driver
		if(isset($val["driver"])) $table[$key]["type"] = $val["driver"];
		else $table[$key]["type"] = "Unknown";
		
		// hw address
		if(isset($val["hwaddress"])) $table[$key]["hwaddress"] = $val["hwaddress"];
		
		// current mtu
		if(isset($val["mtu"])) $table[$key]["mtu"] = $val["mtu"];
	}
	
	foreach($config["hardware"]["netdev"] as $key=>$val) {
		$ename = $key;
		if(isset($config["interface"]["$key"]["name"])) $table[$key]["name"] = $config["interface"]["$key"]["name"];
		$table[$key]["address4"] = null;
		$table[$key]["address6"] = null;
		
		if(isset($config["interface"][$table[$key]["name"]]["address4"])) {
			$table[$key]["address4"] = $config["interface"][$table[$key]["name"]]["address4"];
		}
		
		if(isset($config["interface"][$table[$key]["name"]]["address6"])) {
			$table[$key]["address6"] = $config["interface"][$table[$key]["name"]]["address6"];
		}
		
		if(isset($config["interface"][$table[$key]["name"]]["mtu"])) {
			$table[$key]["mtu"] = $config["interface"][$table[$key]["name"]]["mtu"];
		} else {
			$table[$key]["mtu"] = "1500"; // TODO: this needs to actually come from somewhere
		}
		
		if(isset($config["interface"][$table[$key]["name"]]["speed"])) {
			$table[$key]["speed"] = $config["interface"][$table[$key]["name"]]["speed"];
		} else {
			$table[$key]["speed"] = null;
		}

		if(isset($config["interface"][$table[$key]["name"]]["duplex"])) {
			$table[$key]["duplex"] = $config["interface"][$table[$key]["name"]]["duplex"];
		} else {
			$table[$key]["duplex"] = null;
		}
		
		if(isset($config["interface"][$table[$key]["name"]]["zone"])) {
			$table[$key]["zone"] = $config["interface"][$table[$key]["name"]]["zone"];
		} else {
			$table[$key]["zone"] = null;
		}
	}
	
	
	echo "<table border=\"1\"><th>Device</th><th>Zone</th><th>Type</th><th>MAC Address</th><th>Address</th><th>MTU</th><th>Speed/Duplex</th><th>Control</th></tr>";
	foreach($table as $key =>$val) {
		if($val["realname"] == $val["name"]) $name = $val["name"];
		else $name = $val["name"]." (".$val["realname"].")";
		
		// zone
		if($val["zone"] == null) $zone = "-";
		else $zone = $val["zone"];
		
		// mtu
		$mtu = $val["mtu"];
		
		// driver type
		$type = $val["type"];
		
		// hardware address
		$mac = $val["hwaddress"];
		
		// speed and duplex
		if($val["duplex"] == null) $dup = "default";
		else $dup = $val["duplex"];
		
		if($val["speed"] == null) $spd = "default";
		else $spd = $val["speed"];
		
		$spanddu = "$spd/$dup";
		
		// network address
		if($val["address4"]!=null && $val["address6"]!=null) {
			$address = $val["address4"]."<br>".$val["address6"];
		} else if($val["address4"] != null) {
			$address = $val["address4"];
		} else if($val["address6"] != null) {
			$address = $val["address6"];
		} else {
			$address = "-";
		}
		
		echo "<tr><th>$name</th><td>$zone</td><td>$type</td><td>$mac</td><td>$address</td><td>$mtu</td><td>$spanddu</td><td><a href=\"$BASE_URL/interfaces/edit/".$val["realname"]."\">Edit</a></td></tr>";
	}
	echo "</table>";
}

function CBFWObjectsPage($urls)
{
	$comms = new Comms();
	
	$config = $comms->getConfig();
	
	CBFWpageBuilder(null, "CBFWObjectsDisplay");
}

function CBFWObjectsDisplay()
{
	global $BASE_URL, $MENU_ITEMS;
	$config = getWebUserConfig();
	
	echo "<h2>Objects</h2>";
	
	if(isset($config["objects"])) {
		echo "<table>";
		echo "<tr><th>Networks</th><th>Hosts</th><th>Services</th><th>Network Groups</th><th>Host Groups</th><th>Service Groups</th></tr>";
		echo "</table>";
		foreach($config["objects"] as $key => $var) {
		}
	} else {
		echo "No objects set\n";
	}
	
	echo "<hr>";
	echo "<table cellpadding=\"20\"><tr valign=\"top\">";
	echo "<td>";
	echo "<h3>Create Network</h3><br>";
	echo "<form method=\"post\" action=\"$BASE_URL/objects/network/create\">";
	echo "Name <input type=\"text\" name=\"objname\"><br>";
	echo "IPv4 <input type=\"text\" name=\"addr4\">/<input type=\"text\" name=\"mask4\" maxlength=\"3\" size=\"3\"><br>";
	echo "IPv6 <input type=\"text\" name=\"addr6\">/<input type=\"text\" name=\"mask6\" maxlength=\"3\" size=\"3\"><br>";
	echo "<input type=\"submit\" name=\"add\" value=\"Add\">";
	echo "</form>";
	echo "</td>";
	echo "<td>";
	echo "<h3>Create Host</h3><br>";
	echo "<form method=\"post\" action=\"$BASE_URL/objects/host/create\">";
	echo "Name <input type=\"text\" name=\"objname\"><br>";
	echo "IPv4 <input type=\"text\" name=\"addr4\"><br>";
	echo "IPv6 <input type=\"text\" name=\"addr6\"><br>";
	echo "<input type=\"submit\" name=\"add\" value=\"Add\">";
	echo "</form>";
	echo "</td>";
	echo "<td>";
	echo "<h3>Service</h3><br>";
	echo "<form method=\"post\" action=\"$BASE_URL/objects/host/create\">";
	echo "Name <input type=\"text\" name=\"objname\"><br>";
	echo "Port <input type=\"text\" name=\"port\">";
	echo "<select name=\"proto\"><option value=\"tcp\">TCP</option><option value=\"udp\">UDP</option></select><br>";
	echo "<input type=\"submit\" name=\"add\" value=\"Add\">";
	echo "</form>";
	echo "</td>";
	echo "</tr><tr>";
	echo "<td>";
	echo "<h3>Network Group</h3>";
	echo "<form method=\"post\" action=\"$BASE_URL/objects/networkgroup/create\">";
	echo "Name <input type=\"text\" name=\"objname\"><br>";
	echo "</form>";
	echo "</td>";
	echo "<td>";
	echo "<h3>Host Group</h3>";
	echo "<form method=\"post\" action=\"$BASE_URL/objects/hostgroup/create\">";
	echo "Name <input type=\"text\" name=\"objname\"><br>";
	echo "</form>";
	echo "</td>";
	echo "<td>";
	echo "<h3>Service Group</h3>";
	echo "<form method=\"post\" action=\"$BASE_URL/objects/servicegroup/create\">";
	echo "Name <input type=\"text\" name=\"objname\"><br>";
	echo "</form>";
	echo "</td>";
	
	
	echo "</tr></table>";
	
}

function CBFWRulesPage()
{
	$comms = new Comms();
	
	$config = $comms->getConfig();
}

function CBFWAdminPage($urls)
{
	$comms = new Comms();
	
	$config = $comms->getConfig();
	
	CBFWpageBuilder(null, "CBFWAdminDisplay");
}

function CBFWAdminDisplay()
{
?>
<h2>Administration</h2>
<table cellpadding=10>
<tr valign="top">
<td>
<h3>Users</h3>
<table>
<tr><th>Username</th><th>Description</th><th>Enabled?</th></tr>
<tr><td>Admin</td><td>Twattle</td><td>Yes</td></tr>
</table>
<hr>
<h3>Add User</h3>
<form method="post" action="asdf">
Username <input type="text" name="username"><br>
Password <input type="password" name="pass"><br>
Description <input type="text" name="desc"><br>
<input type="submit" name="add" value="Add"><br>
</form>
</td>
<td>
<h3>Network Access</h3>
<table>
<tr><th>From</th><th>Interface</th><th>Type</th></tr>
<tr><td>Any</td><td>twaddle</td><td>http,https,ssh</td></tr>
</table>
<hr>
<h3>Add Access</h3>
<form method="post" action="asdf">
From <input type="text" name="from"> <i>either "any", an address (1.2.3.4) or a network (1.2.3.4/23)</i><br>
Interface <select><option value="something">twad</option><option name="some">craw</option></select>
Protocols <input type="checkbox" name="http">HTTP <input type="checkbox" name="http">HTTPS <input type="checkbox" name="http">SSH<br> 
<input type="submit" name="add" value="Add"><br>
</form>
</td>
</tr>
</table>
<?php 
}



function findUrl($url_s)
{
	global $URL_HANDLERS;
	
	foreach($URL_HANDLERS as $key => $val) {
		
	}
}
?>